///////////////////////////////////////////////////////////////////
// PerfSleep.h
// 720020-1152x
//
// Applied Data Systems
//
// This class enables applications to suspend execution
// or "sleep" for intervals based on a 100ns tick.  This is
// 10000x more resolution than provided by the Sleep() function.
//
// This class is for the StrongARM processor only
//
// History
// -------
// 720020-11521: June 12, 2003 (ctacke)
//  - Initial release
//
// 720020-11522: Sept 26, 2003 (ctacke)
//  - Added PXA255 support
///////////////////////////////////////////////////////////////////
#include <windows.h>

///////////////////////////////////////////////////////////////////
// uncomment this line for PXA255 processor support
// comment it out for SA1110 support
#define PXA255
///////////////////////////////////////////////////////////////////

class PerfSleep
{
public:
	PerfSleep();
	~PerfSleep();
	void StallExecution(int ticks);

private:
	LPVOID MapAddress(DWORD baseAddress);
	void ReleaseAddress(LPVOID address);

	DWORD *pOSTCtrl;
};