///////////////////////////////////////////////////
// StallTest.cpp
// Part of 720020-1152x PerfSleep
//
// Applied Data Systems
//
// See PerfSleep.h for history and notes.
//
///////////////////////////////////////////////////

#include <windows.h>
#include "perfsleep.h"

#define ITERATIONS 100000 // 100000 ticks == 10ms

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	DWORD et, i, m;
	PerfSleep *perfsleep = new PerfSleep();

	RETAILMSG(TRUE, (_T("<--- Begin StallTest.exe --->\r\n")));
	for(m = 1 ; m <= 1000 ; m*=10)
	{
		et = GetTickCount();

		for(i = 0 ; i < ITERATIONS * m ; i++)
		{
			perfsleep->StallExecution(1);
		}

		// most of this time is actually loop processing
		et = GetTickCount() - et;

		RETAILMSG(TRUE, (_T("%i ticks took %ims\r\n"), (ITERATIONS * m), et));
	}

	RETAILMSG(TRUE, (_T("<--- StallTest.exe done --->\r\n")));

	delete perfsleep;

	return 0;
}